(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('@fortawesome/fontawesome'), require('prop-types'), require('react')) :
	typeof define === 'function' && define.amd ? define(['@fortawesome/fontawesome', 'prop-types', 'react'], factory) :
	(global['react-fontawesome'] = factory(global.FontAwesome,global.PropTypes,global.React));
}(this, (function (fontawesome,PropTypes,React) { 'use strict';

fontawesome = fontawesome && fontawesome.hasOwnProperty('default') ? fontawesome['default'] : fontawesome;
PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
React = React && React.hasOwnProperty('default') ? React['default'] : React;

'use strict';

function preserveCamelCase(str) {
	let isLastCharLower = false;
	let isLastCharUpper = false;
	let isLastLastCharUpper = false;

	for (let i = 0; i < str.length; i++) {
		const c = str[i];

		if (isLastCharLower && /[a-zA-Z]/.test(c) && c.toUpperCase() === c) {
			str = str.substr(0, i) + '-' + str.substr(i);
			isLastCharLower = false;
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = true;
			i++;
		} else if (isLastCharUpper && isLastLastCharUpper && /[a-zA-Z]/.test(c) && c.toLowerCase() === c) {
			str = str.substr(0, i - 1) + '-' + str.substr(i - 1);
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = false;
			isLastCharLower = true;
		} else {
			isLastCharLower = c.toLowerCase() === c;
			isLastLastCharUpper = isLastCharUpper;
			isLastCharUpper = c.toUpperCase() === c;
		}
	}

	return str;
}

var camelcase = function (str) {
	if (arguments.length > 1) {
		str = Array.from(arguments)
			.map(x => x.trim())
			.filter(x => x.length)
			.join('-');
	} else {
		str = str.trim();
	}

	if (str.length === 0) {
		return '';
	}

	if (str.length === 1) {
		return str.toLowerCase();
	}

	if (/^[a-z0-9]+$/.test(str)) {
		return str;
	}

	const hasUpperCase = str !== str.toLowerCase();

	if (hasUpperCase) {
		str = preserveCamelCase(str);
	}

	return str
		.replace(/^[_.\- ]+/, '')
		.toLowerCase()
		.replace(/[_.\- ]+(\w|$)/g, (m, p1) => p1.toUpperCase());
};

function capitalize(val) {
  return val.charAt(0).toUpperCase() + val.slice(1);
}

function styleToObject(style) {
  return style.split(';').map(function (s) {
    return s.trim();
  }).filter(function (s) {
    return s;
  }).reduce(function (acc, pair) {
    var i = pair.indexOf(':');
    var prop = camelcase(pair.slice(0, i));
    var value = pair.slice(i + 1).trim();

    prop.startsWith('webkit') ? acc[capitalize(prop)] = value : acc[prop] = value;

    return acc;
  }, {});
}

function convert(createElement, element) {
  var children = (element.children || []).map(convert.bind(null, createElement));

  if (element.attributes.hasOwnProperty('class')) {
    element.attributes['className'] = element.attributes['class'];
    delete element.attributes['class'];
  }

  Object.keys(element.attributes).forEach(function (key) {
    var val = element.attributes[key];

    switch (key) {
      case 'class':
        element.attributes['className'] = val;
        delete element.attributes['class'];
        break;
      case 'style':
        element.attributes['style'] = styleToObject(val);
        break;
    }
  });

  return createElement(element.tag, element.attributes, children.length > 1 ? children : children[0]);
}

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var packNames = {
  brands: 'fab',
  light: 'fal',
  regular: 'far',
  solid: 'fas'
};

var FontAwesomeIcon$1 = function (_React$Component) {
  _inherits(FontAwesomeIcon, _React$Component);

  function FontAwesomeIcon() {
    _classCallCheck(this, FontAwesomeIcon);

    return _possibleConstructorReturn(this, (FontAwesomeIcon.__proto__ || Object.getPrototypeOf(FontAwesomeIcon)).apply(this, arguments));
  }

  _createClass(FontAwesomeIcon, [{
    key: '_prefix',
    value: function _prefix() {
      return packNames[this.props.pack] || this.props.pack;
    }
  }, {
    key: '_iconConfig',
    value: function _iconConfig() {
      return { prefix: this._prefix(), iconName: this.props.name };
    }
  }, {
    key: '_classList',
    value: function _classList() {
      var _classes;

      var classes = (_classes = {
        'fa-spin': this.props.spin,
        'fa-pulse': this.props.pulse,
        'fa-fw': this.props.fixedWidth,
        'fa-border': this.props.border,
        'fa-li': this.props.listItem,
        'fa-flip-horizontal': this.props.flip === 'horizontal' || this.props.flip === 'both',
        'fa-flip-vertical': this.props.flip === 'vertical' || this.props.flip === 'both'
      }, _defineProperty(_classes, 'fa-' + this.props.size, this.props.size !== null), _defineProperty(_classes, 'fa-rotate-' + this.props.rotation, this.props.rotation !== null), _defineProperty(_classes, 'fa-pull-' + this.props.pull, this.props.pull !== null), _classes);

      return Object.keys(classes).map(function (key) {
        return classes[key] ? key : null;
      }).filter(function (key) {
        return key;
      });
    }
  }, {
    key: '_transformDirectives',
    value: function _transformDirectives() {
      return typeof this.props.transform === 'string' ? fontawesome.parse.transform(this.props.transform) : this.props.transform;
    }
  }, {
    key: 'render',
    value: function render() {
      var classes = this._classList().length > 0 ? { classes: this._classList() } : {};
      var transform = this._transformDirectives() ? { transform: this._transformDirectives() } : {};

      var _fontawesome$icon = fontawesome.icon(this.props.iconDefinition || this._iconConfig(), _extends({}, classes, transform)),
          abstract = _fontawesome$icon.abstract;

      var convertCurry = convert.bind(null, React.createElement);

      return convertCurry(abstract[0]);
    }
  }]);

  return FontAwesomeIcon;
}(React.Component);

FontAwesomeIcon$1.propTypes = {
  border: PropTypes.bool,

  fixedWidth: PropTypes.bool,

  flip: PropTypes.oneOf(['horizontal', 'vertical', 'both']),

  iconDefinition: PropTypes.object,

  listItem: PropTypes.bool,

  pack: PropTypes.string,

  pull: PropTypes.oneOf(['right', 'left']),

  pulse: PropTypes.bool,

  name: PropTypes.string,

  rotation: PropTypes.oneOf([90, 180, 270]),

  size: PropTypes.oneOf(['lg', 'xs', 'sm', '1x', '2x', '3x', '4x', '5x', '6x', '7x', '8x', '9x', '10x']),

  spin: PropTypes.bool,

  transform: PropTypes.oneOfType([PropTypes.string, PropTypes.object])
};

FontAwesomeIcon$1.defaultProps = {
  border: false,
  fixedWidth: false,
  flip: null,
  iconDefinition: null,
  listItem: false,
  pack: 'fa',
  pull: null,
  pulse: false,
  name: '',
  rotation: null,
  size: null,
  spin: false,
  transform: null
};

return FontAwesomeIcon$1;

})));
